#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lua.h"
#include "lparser.h"
#include "lzio.h"
/* #include "luac.h" */

static int incomplete;

#define l_s(x) x

static int trap_eof (lua_State *l) {
 const char *s = lua_tostring(l, 1);
 if (strstr(s, "last token read: `<eof>'") != NULL)
   incomplete = 1;
 else
   fprintf(stderr, "error: %s\n", s);
 return 0;
}



int is_incomplete(lua_State *L, char *s, int len)
{
  ZIO z;
  Proto* tf;
  
  incomplete = 0;

  lua_getglobal(L, l_s(LUA_ERRORMESSAGE));
  lua_register(L, l_s(LUA_ERRORMESSAGE), trap_eof);


  luaZ_mopen(&z, s, len, "=stdin");
  
  tf = luaY_parser(L, &z);

  lua_setglobal(L, l_s(LUA_ERRORMESSAGE));

  return incomplete;
}

